'pure qbasic pixel scroller.
'166 fs compiled in a P4 1.4 2                21.5 fps in ide
'pure basic multikey routine (works ok only if compiled, not so good in the IDE)
'tile size and map size must be both square and a power of 2
'a routine changing randomly the map each frame proves all screen is redrawn
'Use the arrow keys to scroll, press 5 at keypad for speed


'by Antoni Gual agual@eic.ictnet.es
SCREEN 13
DEFINT A-Z

'tile array
CONST tiles = 6
CONST tsize = 32
CONST tsize1 = tsize - 1
CONST t2 = tsize * tsize
DIM text(-1& + tsize * tiles * tsize)
'create some tiles
FOR i = 0 TO tsize1
    FOR j = 0 TO tsize1
       
        text(i * tsize + j) = (i AND j) * 8
        PSET (i, j), text(i * tsize + j)
       
        t1 = tsize: temp = t2
        text(temp + i * tsize + j) = (i MOD (j + 1)) * 16 + 2
        PSET (i + t1, j), text(temp + i * tsize + j)
       
        t1 = t1 + tsize: temp = temp + t2
        text(temp + i * tsize + j) = (i * (tsize - j))
        PSET (i + t1, j), text(temp + i * tsize + j)
       
        t1 = t1 + tsize: temp = temp + t2
        text(temp + i * tsize + j) = (i \ (j + 1))
        PSET (i + t1, j), text(temp + i * tsize + j)
       
        t1 = t1 + tsize: temp = temp + t2
        text(temp + i * tsize + j) = i
        PSET (i + t1, j), text(temp + i * tsize + j)
       
        t1 = t1 + tsize: temp = temp + t2
        text(temp + i * tsize + j) = j
        PSET (i + t1, j), text(temp + i * tsize + j)
NEXT j, i

'map array
CONST msize = 64
CONST msize1 = msize - 1
DIM map(0 TO msize1, 0 TO msize1)
FOR i = 0 TO msize1: FOR j = 0 TO msize1: map(i, j) = INT(RND * tiles) * t2: NEXT j, i

CONST mmod = tsize * msize - 1

'divisor LUT
DIM mdiv(0 TO mmod): FOR i = 1 TO mmod: mdiv(i) = i \ tsize: NEXT

DIM tmul(tsize1): FOR i = 0 TO tsize1: tmul(i) = i * tsize: NEXT


DIM kbd(127)
'buffer
DIM buffer(-8 TO 32001 - 8)
buffer(-2) = 320 * 8
buffer(-1) = 200

'bufer line lut
DIM ylut(199)
temp& = VARSEG(buffer(-8)) + 1
FOR i = 0 TO 199: ylut(i) = temp&: temp& = temp& + 20: NEXT

DIM xlut(319), xlut1(319)


'slow down kbd rate
OUT &H60, &HF3: OUT &H60, 0
WHILE LEN(INKEY$): WEND
CLS

'start top left corner coords
tlxc = 0: tlcy = 0

'fill buffer for the first time

t! = TIMER
f = 0
'main loop
ic = 1
DO
    f = f + 1
    DEF SEG = &H40: POKE &H1C, PEEK(&H1A)
    k = INP(&H60): kbd(k AND 127) = -((k AND 128) = 0)
    IF kbd(&H4C) THEN ic = 3 ELSE ic = 1
    IF kbd(1) THEN EXIT DO
    IF kbd(&H4D) THEN
        dx = ic: tlcx = tlcx + dx AND mmod
    ELSEIF kbd(&H4B) THEN
        dx = -ic: tlcx = tlcx + dx AND mmod
    END IF
    IF kbd(&H50) THEN
        dy = ic: tlcy = tlcy + dy AND mmod
    ELSEIF kbd(&H48) THEN
        dy = -ic: tlcy = tlcy + dy AND mmod
    END IF
       
    'redraw all buffer
    yy = tlcy - 1: ly = -1
    FOR y = 0 TO 199
       yy = (yy + 1) AND mmod
       ym = mdiv(yy)
       IF ly <> ym THEN
           xx = tlcx
           FOR x = 0 TO 319
                xlut1(x) = (tmul(xx AND tsize1) OR map(mdiv(xx), ym))
                xx = (xx + 1) AND mmod
           NEXT
           SWAP ly, ym
       END IF
       'this intermediate loop makes exes faster but is slow in the ide
       yt = yy AND tsize1
       FOR x = 0 TO 319: xlut(x) = text(xlut1(x) + yt): NEXT
       DEF SEG = ylut(y)
       FOR x = 0 TO 319: POKE x, xlut(x): NEXT x
    NEXT y
    PUT (0, 0), buffer(-2), PSET

    'randomly change map in each frame to prove all screen is fully redrawn
    FOR i = 1 TO 10
        map(INT(RND * msize), INT(RND * msize)) = INT(RND * tiles) * t2
    NEXT
LOOP

'display frames and set back keyboard rate
PRINT f / (TIMER - t!)
OUT &H60, &HF3: OUT &H60, 5
a$ = INPUT$(1)
END

SUB clrbuf
REDIM buffer(-8 TO 32001 - 8)
buffer(-2) = 320 * 8
buffer(-1) = 0
END SUB

